//WAEmuWnd.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "resource.h"
#include "MainWnd.h"
#include "AboutDlg.h"
#include "WAEmuWnd.h"
#include "Volume.h"
#include "out/MultiDllOutput.h"
#include "In/MultiDllInput.h"
#include "SeekDialog.h"
#include <wa_ipc.h>
#include "wa_msgids.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "PlaylistManager.h"
#include <zlib.h>
#include "SettingsDialog.h"
#include <ipc_pe.h>
#include "tagz.h"
#include <math.h>
#include "in/CommonFunc.h"
#include "WinampWnd.h"
#include <wa_hotkeys.h>
#include "service.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CArray<char *, char*> registerID;

prefsDlgRec* prefs;
extern CPtrArray listPrefs;
extern int infoBitrate;
extern int infoSamplerate;
extern int infoStereo; 
extern int infoSynched;

CService service;

/////////////////////////////////////////////////////////////////////////////
//CWAEmuWnd

IMPLEMENT_DYNCREATE(CWAEmuWnd, CFrameWnd)

HWND eWindow(embedWindowState * eWS)
{
	return WAEmuWnd->embedWindow(eWS);
}
HWND CWAEmuWnd::embedWindow(embedWindowState* eWS)
{
	CWinampWnd* myWnd = new CWinampWnd();
	listWnd.Add(myWnd);
	myWnd->Create(WAEmuWnd);
	CRect rect(eWS->r);
	//rect.InflateRect(-10, -20, 18, 34);
	//myWnd->ShowWindow(SW_SHOW);
	myWnd->SetWindowPos(NULL, rect.left, rect.bottom, rect.Width(), rect.Height(), SWP_NOZORDER | SWP_NOMOVE);
	//myWnd->ShowWindow(SW_HIDE);
	return myWnd->m_hWnd;
}

/////////////////////////////////////////////////////////////////////////////
//CWAEmuWnd message handlers
CWAEmuWnd::CWAEmuWnd()
{
	vidOut = new CVidOut();
	vidOut->Create(CVidOut::IDD);
	iVidOut = new CIVideoOutput();
	iVidOut->SetVidOut(vidOut);
	image = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_GENSKIN), IMAGE_BITMAP, 130, 75, LR_DEFAULTCOLOR);
	GetModuleFileNameA(NULL, szWinampInipath, MAX_PATH - 1);
	char* szWalk = szWinampInipath + strlen(szWinampInipath) - 1;
	while ((szWalk > szWinampInipath) && (*szWalk != '.'))
		szWalk--;
	szWalk++;
	strcpy(szWalk, "ini");
	GetModuleFileNameA(NULL, szPluginInipath, MAX_PATH - 1);
	szWalk = szPluginInipath + strlen(szPluginInipath) - 1;
	while ((szWalk > szPluginInipath) && (*szWalk != '\\'))
		szWalk--;
	szWalk++;
	strcpy(szWalk, "Plugins\\");
	length_in_ms = 0;
	GetTempPathA(MAX_PATH - 1, szPath);
	strcpy(szPathGen, szPath);
	strcat(szPathGen, "GEN.bmp");
	Strcpy(pathGen, sizeof(pathGen), szPathGen);

	WNDCLASS wndcls;
	memset(&wndcls, 0, sizeof(WNDCLASS));

	wndcls.style = CS_HREDRAW | CS_VREDRAW;
	wndcls.cbWndExtra = DLGWINDOWEXTRA;
	wndcls.cbClsExtra = 0;
	wndcls.lpfnWndProc = ::DefWindowProc;
	wndcls.hInstance = AfxGetInstanceHandle();
	wndcls.hIcon = AfxGetApp()->LoadIcon(IDI_STP);
	wndcls.hCursor = AfxGetApp()->LoadCursor(IDC_ARROW);
	wndcls.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wndcls.lpszMenuName = NULL;

	wndcls.lpszClassName = _T("STPAppChildClass");

	AfxRegisterClass(&wndcls);
}

CWAEmuWnd::~CWAEmuWnd()
{
	delete vidOut;
	vidOut = NULL;
	delete iVidOut;
	iVidOut = NULL;
	WAEmuWnd = NULL;

	listPrefs.RemoveAll();

	for (int i = listWnd.GetSize() - 1; i >= 0; i--)
	{
		CWinampWnd* wnd = listWnd.GetAt(i);
		listWnd.RemoveAt(i);
		delete wnd;
	}
}

BOOL CWAEmuWnd::DestroyWindow()
{
	pMainFrame->OnPopupMenuExit();
	pMainFrame->Created = false;
	return CFrameWnd::DestroyWindow();
}

void CWAEmuWnd::OnClose()
{
}
BEGIN_MESSAGE_MAP(CWAEmuWnd, CFrameWnd)
	ON_WM_CLOSE()
	ON_COMMAND(WINAMP_FILE_QUIT, OnMessageWINAMP_FILE_QUIT)
	ON_COMMAND(WINAMP_OPTIONS_PREFS, OnMessageWINAMP_OPTIONS_PREFS)
	ON_COMMAND(WINAMP_OPTIONS_AOT, OnMessageWINAMP_OPTIONS_AOT)
	ON_COMMAND(WINAMP_FILE_REPEAT, OnMessageWINAMP_FILE_REPEAT)
	ON_COMMAND(WINAMP_FILE_SHUFFLE, OnMessageWINAMP_FILE_SHUFFLE)
	ON_COMMAND(WINAMP_HIGH_PRIORITY, OnMessageWINAMP_HIGH_PRIORITY)
	ON_COMMAND(WINAMP_FILE_PLAY, OnMessageWINAMP_FILE_PLAY)
	ON_COMMAND(WINAMP_OPTIONS_EQ, OnMessageWINAMP_OPTIONS_EQ)
	ON_COMMAND(WINAMP_OPTIONS_ELAPSED, OnMessageWINAMP_OPTIONS_ELAPSED)
	ON_COMMAND(WINAMP_OPTIONS_REMAINING, OnMessageWINAMP_OPTIONS_REMAINING)
	ON_COMMAND(WINAMP_OPTIONS_PLEDIT, OnMessageWINAMP_OPTIONS_PLEDIT)
	ON_COMMAND(WINAMP_HELP_ABOUT, OnMessageWINAMP_HELP_ABOUT)
	ON_COMMAND(WINAMP_MAINMENU, OnMessageWINAMP_MAINMENU)
	ON_COMMAND(WINAMP_BUTTON1, OnMessageWINAMP_BUTTON1)
	ON_COMMAND(WINAMP_BUTTON2, OnMessageWINAMP_BUTTON2)
	ON_COMMAND(WINAMP_BUTTON3, OnMessageWINAMP_BUTTON3)
	ON_COMMAND(WINAMP_BUTTON4, OnMessageWINAMP_BUTTON4)
	ON_COMMAND(WINAMP_BUTTON5, OnMessageWINAMP_BUTTON5)
	ON_COMMAND(WINAMP_BUTTON1_SHIFT, OnMessageWINAMP_BUTTON1_SHIFT)
	ON_COMMAND(WINAMP_BUTTON2_SHIFT, OnMessageWINAMP_BUTTON2_SHIFT)
	ON_COMMAND(WINAMP_BUTTON3_SHIFT, OnMessageWINAMP_BUTTON3_SHIFT)
	ON_COMMAND(WINAMP_BUTTON4_SHIFT, OnMessageWINAMP_BUTTON4_SHIFT)
	ON_COMMAND(WINAMP_BUTTON5_SHIFT, OnMessageWINAMP_BUTTON5_SHIFT)
	ON_COMMAND(WINAMP_BUTTON1_CTRL, OnMessageWINAMP_BUTTON1_CTRL)
	ON_COMMAND(WINAMP_BUTTON2_CTRL, OnMessageWINAMP_BUTTON2_CTRL)
	ON_COMMAND(WINAMP_BUTTON3_CTRL, OnMessageWINAMP_BUTTON3_CTRL)
	ON_COMMAND(WINAMP_BUTTON4_CTRL, OnMessageWINAMP_BUTTON4_CTRL)
	ON_COMMAND(WINAMP_BUTTON5_CTRL, OnMessageWINAMP_BUTTON5_CTRL)
	ON_COMMAND(WINAMP_VOLUMEUP, OnMessageWINAMP_VOLUMEUP)
	ON_COMMAND(WINAMP_VOLUMEDOWN, OnMessageWINAMP_VOLUMEDOWN)
	ON_COMMAND(WINAMP_FFWD5S, OnMessageWINAMP_FFWD5S)
	ON_COMMAND(WINAMP_REW5S, OnMessageWINAMP_REW5S)
	ON_COMMAND(WINAMP_NEXT_WINDOW, OnMessageWINAMP_NEXT_WINDOW)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE, OnMessageWINAMP_OPTIONS_WINDOWSHADE)
	ON_COMMAND(WINAMP_OPTIONS_DSIZE, OnMessageWINAMP_OPTIONS_DSIZE)
	ON_COMMAND(IDC_SORT_FILENAME, OnMessageIDC_SORT_FILENAME)
	ON_COMMAND(IDC_SORT_FILETITLE, OnMessageIDC_SORT_FILETITLE)
	ON_COMMAND(IDC_SORT_ENTIREFILENAME, OnMessageIDC_SORT_ENTIREFILENAME)
	ON_COMMAND(IDC_SELECTALL, OnMessageIDC_SELECTALL)
	ON_COMMAND(IDC_SELECTNONE, OnMessageIDC_SELECTNONE)
	ON_COMMAND(IDC_SELECTINV, OnMessageIDC_SELECTINV)
	ON_COMMAND(IDM_EQ_LOADPRE, OnMessageIDM_EQ_LOADPRE)
	ON_COMMAND(IDM_EQ_LOADMP3, OnMessageIDM_EQ_LOADMP3)
	ON_COMMAND(IDM_EQ_LOADDEFAULT, OnMessageIDM_EQ_LOADDEFAULT)
	ON_COMMAND(IDM_EQ_SAVEPRE, OnMessageIDM_EQ_SAVEPRE)
	ON_COMMAND(IDM_EQ_SAVEMP3, OnMessageIDM_EQ_SAVEMP3)
	ON_COMMAND(IDM_EQ_SAVEDEFAULT, OnMessageIDM_EQ_SAVEDEFAULT)
	ON_COMMAND(IDM_EQ_DELPRE, OnMessageIDM_EQ_DELPRE)
	ON_COMMAND(IDM_EQ_DELMP3, OnMessageIDM_EQ_DELMP3)
	ON_COMMAND(IDC_PLAYLIST_PLAY, OnMessageIDC_PLAYLIST_PLAY)
	ON_COMMAND(WINAMP_FILE_LOC, OnMessageWINAMP_FILE_LOC)
	ON_COMMAND(WINAMP_OPTIONS_EASYMOVE, OnMessageWINAMP_OPTIONS_EASYMOVE)
	ON_COMMAND(WINAMP_FILE_DIR, OnMessageWINAMP_FILE_DIR)
	ON_COMMAND(WINAMP_EDIT_ID3, OnMessageWINAMP_EDIT_ID3)
	ON_COMMAND(WINAMP_TOGGLE_AUTOSCROLL, OnMessageWINAMP_TOGGLE_AUTOSCROLL)
	ON_COMMAND(WINAMP_VISSETUP, OnMessageWINAMP_VISSETUP)
	ON_COMMAND(WINAMP_PLGSETUP, OnMessageWINAMP_PLGSETUP)
	ON_COMMAND(WINAMP_VISPLUGIN, OnMessageWINAMP_VISPLUGIN)
	ON_COMMAND(WINAMP_JUMP, OnMessageWINAMP_JUMP)
	ON_COMMAND(WINAMP_JUMPFILE, OnMessageWINAMP_JUMPFILE)
	ON_COMMAND(WINAMP_JUMP10FWD, OnMessageWINAMP_JUMP10FWD)
	ON_COMMAND(WINAMP_JUMP10BACK, OnMessageWINAMP_JUMP10BACK)
	ON_COMMAND(WINAMP_PREVSONG, OnMessageWINAMP_PREVSONG)
	ON_COMMAND(WINAMP_OPTIONS_EXTRAHQ, OnMessageWINAMP_OPTIONS_EXTRAHQ)
	ON_COMMAND(ID_PE_NEW, OnMessageID_PE_NEW)
	ON_COMMAND(ID_PE_OPEN, OnMessageID_PE_OPEN)
	ON_COMMAND(ID_PE_SAVE, OnMessageID_PE_SAVE)
	ON_COMMAND(ID_PE_SAVEAS, OnMessageID_PE_SAVEAS)
	ON_COMMAND(ID_PE_SELECTALL, OnMessageID_PE_SELECTALL)
	ON_COMMAND(ID_PE_INVERT, OnMessageID_PE_INVERT)
	ON_COMMAND(ID_PE_NONE, OnMessageID_PE_NONE)
	ON_COMMAND(ID_PE_ID3, OnMessageID_PE_ID3)
	ON_COMMAND(ID_PE_S_TITLE, OnMessageID_PE_S_TITLE)
	ON_COMMAND(ID_PE_S_FILENAME, OnMessageID_PE_S_FILENAME)
	ON_COMMAND(ID_PE_S_PATH, OnMessageID_PE_S_PATH)
	ON_COMMAND(ID_PE_S_RANDOM, OnMessageID_PE_S_RANDOM)
	ON_COMMAND(ID_PE_S_REV, OnMessageID_PE_S_REV)
	ON_COMMAND(ID_PE_CLEAR, OnMessageID_PE_CLEAR)
	ON_COMMAND(ID_PE_MOVEUP, OnMessageID_PE_MOVEUP)
	ON_COMMAND(ID_PE_MOVEDOWN, OnMessageID_PE_MOVEDOWN)
	ON_COMMAND(WINAMP_SELSKIN, OnMessageWINAMP_SELSKIN)
	ON_COMMAND(WINAMP_VISCONF, OnMessageWINAMP_VISCONF)
	ON_COMMAND(ID_PE_NONEXIST, OnMessageID_PE_NONEXIST)
	ON_COMMAND(ID_PE_DELETEFROMDISK, OnMessageID_PE_DELETEFROMDISK)
	ON_COMMAND(ID_PE_CLOSE, OnMessageID_PE_CLOSE)
	ON_COMMAND(WINAMP_VIS_SETOSC, OnMessageWINAMP_VIS_SETOSC)
	ON_COMMAND(WINAMP_VIS_SETANA, OnMessageWINAMP_VIS_SETANA)
	ON_COMMAND(WINAMP_VIS_SETOFF, OnMessageWINAMP_VIS_SETOFF)
	ON_COMMAND(WINAMP_VIS_DOTSCOPE, OnMessageWINAMP_VIS_DOTSCOPE)
	ON_COMMAND(WINAMP_VIS_LINESCOPE, OnMessageWINAMP_VIS_LINESCOPE)
	ON_COMMAND(WINAMP_VIS_SOLIDSCOPE, OnMessageWINAMP_VIS_SOLIDSCOPE)
	ON_COMMAND(WINAMP_VIS_NORMANA, OnMessageWINAMP_VIS_NORMANA)
	ON_COMMAND(WINAMP_VIS_FIREANA, OnMessageWINAMP_VIS_FIREANA)
	ON_COMMAND(WINAMP_VIS_LINEANA, OnMessageWINAMP_VIS_LINEANA)
	ON_COMMAND(WINAMP_VIS_NORMVU, OnMessageWINAMP_VIS_NORMVU)
	ON_COMMAND(WINAMP_VIS_SMOOTHVU, OnMessageWINAMP_VIS_SMOOTHVU)
	ON_COMMAND(WINAMP_VIS_FULLREF, OnMessageWINAMP_VIS_FULLREF)
	ON_COMMAND(WINAMP_VIS_FULLREF2, OnMessageWINAMP_VIS_FULLREF2)
	ON_COMMAND(WINAMP_VIS_FULLREF3, OnMessageWINAMP_VIS_FULLREF3)
	ON_COMMAND(WINAMP_VIS_FULLREF4, OnMessageWINAMP_VIS_FULLREF4)
	ON_COMMAND(WINAMP_OPTIONS_TOGTIME, OnMessageWINAMP_OPTIONS_TOGTIME)
	ON_COMMAND(EQ_ENABLE, OnMessageEQ_ENABLE)
	ON_COMMAND(EQ_AUTO, OnMessageEQ_AUTO)
	ON_COMMAND(EQ_PRESETS, OnMessageEQ_PRESETS)
	ON_COMMAND(WINAMP_VIS_FALLOFF0, OnMessageWINAMP_VIS_FALLOFF0)
	ON_COMMAND(WINAMP_VIS_FALLOFF1, OnMessageWINAMP_VIS_FALLOFF1)
	ON_COMMAND(WINAMP_VIS_FALLOFF2, OnMessageWINAMP_VIS_FALLOFF2)
	ON_COMMAND(WINAMP_VIS_FALLOFF3, OnMessageWINAMP_VIS_FALLOFF3)
	ON_COMMAND(WINAMP_VIS_FALLOFF4, OnMessageWINAMP_VIS_FALLOFF4)
	ON_COMMAND(WINAMP_VIS_PEAKS, OnMessageWINAMP_VIS_PEAKS)
	ON_COMMAND(ID_LOAD_EQF, OnMessageID_LOAD_EQF)
	ON_COMMAND(ID_SAVE_EQF, OnMessageID_SAVE_EQF)
	ON_COMMAND(ID_PE_ENTRY, OnMessageID_PE_ENTRY)
	ON_COMMAND(ID_PE_SCROLLUP, OnMessageID_PE_SCROLLUP)
	ON_COMMAND(ID_PE_SCROLLDOWN, OnMessageID_PE_SCROLLDOWN)
	ON_COMMAND(WINAMP_MAIN_WINDOW, OnMessageWINAMP_MAIN_WINDOW)
	ON_COMMAND(WINAMP_VIS_PFALLOFF0, OnMessageWINAMP_VIS_PFALLOFF0)
	ON_COMMAND(WINAMP_VIS_PFALLOFF1, OnMessageWINAMP_VIS_PFALLOFF1)
	ON_COMMAND(WINAMP_VIS_PFALLOFF2, OnMessageWINAMP_VIS_PFALLOFF2)
	ON_COMMAND(WINAMP_VIS_PFALLOFF3, OnMessageWINAMP_VIS_PFALLOFF3)
	ON_COMMAND(WINAMP_VIS_PFALLOFF4, OnMessageWINAMP_VIS_PFALLOFF4)
	ON_COMMAND(ID_PE_TOP, OnMessageID_PE_TOP)
	ON_COMMAND(ID_PE_BOTTOM, OnMessageID_PE_BOTTOM)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE_PL, OnMessageWINAMP_OPTIONS_WINDOWSHADE_PL)
	ON_COMMAND(EQ_INC1, OnMessageEQ_INC1)
	ON_COMMAND(EQ_INC2, OnMessageEQ_INC2)
	ON_COMMAND(EQ_INC3, OnMessageEQ_INC3)
	ON_COMMAND(EQ_INC4, OnMessageEQ_INC4)
	ON_COMMAND(EQ_INC5, OnMessageEQ_INC5)
	ON_COMMAND(EQ_INC6, OnMessageEQ_INC6)
	ON_COMMAND(EQ_INC7, OnMessageEQ_INC7)
	ON_COMMAND(EQ_INC8, OnMessageEQ_INC8)
	ON_COMMAND(EQ_INC9, OnMessageEQ_INC9)
	ON_COMMAND(EQ_INC10, OnMessageEQ_INC10)
	ON_COMMAND(EQ_INCPRE, OnMessageEQ_INCPRE)
	ON_COMMAND(EQ_DECPRE, OnMessageEQ_DECPRE)
	ON_COMMAND(EQ_DEC1, OnMessageEQ_DEC1)
	ON_COMMAND(EQ_DEC2, OnMessageEQ_DEC2)
	ON_COMMAND(EQ_DEC3, OnMessageEQ_DEC3)
	ON_COMMAND(EQ_DEC4, OnMessageEQ_DEC4)
	ON_COMMAND(EQ_DEC5, OnMessageEQ_DEC5)
	ON_COMMAND(EQ_DEC6, OnMessageEQ_DEC6)
	ON_COMMAND(EQ_DEC7, OnMessageEQ_DEC7)
	ON_COMMAND(EQ_DEC8, OnMessageEQ_DEC8)
	ON_COMMAND(EQ_DEC9, OnMessageEQ_DEC9)
	ON_COMMAND(EQ_DEC10, OnMessageEQ_DEC10)
	ON_COMMAND(ID_PE_SCUP, OnMessageID_PE_SCUP)
	ON_COMMAND(ID_PE_SCDOWN, OnMessageID_PE_SCDOWN)
	ON_COMMAND(WINAMP_REFRESHSKIN, OnMessageWINAMP_REFRESHSKIN)
	ON_COMMAND(ID_PE_PRINT, OnMessageID_PE_PRINT)
	ON_COMMAND(ID_PE_EXTINFO, OnMessageID_PE_EXTINFO)
	ON_COMMAND(WINAMP_PLAYLIST_ADVANCE, OnMessageWINAMP_PLAYLIST_ADVANCE)
	ON_COMMAND(WINAMP_VIS_LIN, OnMessageWINAMP_VIS_LIN)
	ON_COMMAND(WINAMP_VIS_BAR, OnMessageWINAMP_VIS_BAR)
	ON_COMMAND(WINAMP_OPTIONS_MINIBROWSER, OnMessageWINAMP_OPTIONS_MINIBROWSER)
	ON_COMMAND(MB_FWD, OnMessageMB_FWD)
	ON_COMMAND(MB_BACK, OnMessageMB_BACK)
	ON_COMMAND(MB_RELOAD, OnMessageMB_RELOAD)
	ON_COMMAND(MB_OPENMENU, OnMessageMB_OPENMENU)
	ON_COMMAND(MB_OPENLOC, OnMessageMB_OPENLOC)
	ON_COMMAND(WINAMP_NEW_INSTANCE, OnMessageWINAMP_NEW_INSTANCE)
	ON_COMMAND(MB_UPDATE, OnMessageMB_UPDATE)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE_EQ, OnMessageWINAMP_OPTIONS_WINDOWSHADE_EQ)
	ON_COMMAND(EQ_PANLEFT, OnMessageEQ_PANLEFT)
	ON_COMMAND(EQ_PANRIGHT, OnMessageEQ_PANRIGHT)
	ON_COMMAND(WINAMP_GETMORESKINS, OnMessageWINAMP_GETMORESKINS)
	ON_COMMAND(WINAMP_VIS_OPTIONS, OnMessageWINAMP_VIS_OPTIONS)
	ON_COMMAND(WINAMP_PE_SEARCH, OnMessageWINAMP_PE_SEARCH)
	ON_COMMAND(ID_PE_BOOKMARK, OnMessageID_PE_BOOKMARK)
	ON_COMMAND(WINAMP_EDIT_BOOKMARKS, OnMessageWINAMP_EDIT_BOOKMARKS)
	ON_COMMAND(WINAMP_MAKECURBOOKMARK, OnMessageWINAMP_MAKECURBOOKMARK)
	ON_COMMAND(ID_MAIN_PLAY_BOOKMARK_NONE, OnMessageID_MAIN_PLAY_BOOKMARK_NONE)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD, OnMessageID_MAIN_PLAY_AUDIOCD)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD2, OnMessageID_MAIN_PLAY_AUDIOCD2)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD3, OnMessageID_MAIN_PLAY_AUDIOCD3)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD4, OnMessageID_MAIN_PLAY_AUDIOCD4)
	ON_COMMAND(WINAMP_OPTIONS_VIDEO, OnMessageWINAMP_OPTIONS_VIDEO)
	ON_COMMAND(ID_VIDEOWND_ZOOMFULLSCREEN, OnMessageID_VIDEOWND_ZOOMFULLSCREEN)
	ON_COMMAND(ID_VIDEOWND_ZOOM100, OnMessageID_VIDEOWND_ZOOM100)
	ON_COMMAND(ID_VIDEOWND_ZOOM200, OnMessageID_VIDEOWND_ZOOM200)
	ON_COMMAND(ID_VIDEOWND_ZOOM50, OnMessageID_VIDEOWND_ZOOM50)
	ON_COMMAND(ID_VIDEOWND_VIDEOOPTIONS, OnMessageID_VIDEOWND_VIDEOOPTIONS)
	ON_COMMAND(WINAMP_MINIMIZE, OnMessageWINAMP_MINIMIZE)
	ON_COMMAND(ID_PE_FONTBIGGER, OnMessageID_PE_FONTBIGGER)
	ON_COMMAND(ID_PE_FONTSMALLER, OnMessageID_PE_FONTSMALLER)
	ON_COMMAND(WINAMP_VIDEO_TOGGLE_FS, OnMessageWINAMP_VIDEO_TOGGLE_FS)
	ON_COMMAND(WINAMP_VIDEO_TVBUTTON, OnMessageWINAMP_VIDEO_TVBUTTON)
	ON_COMMAND(WINAMP_LIGHTNING_CLICK, OnMessageWINAMP_LIGHTNING_CLICK)
	ON_COMMAND(ID_FILE_ADDTOLIBRARY, OnMessageID_FILE_ADDTOLIBRARY)
	ON_COMMAND(ID_HELP_HELPTOPICS, OnMessageID_HELP_HELPTOPICS)
	ON_COMMAND(ID_HELP_GETTINGSTARTED, OnMessageID_HELP_GETTINGSTARTED)
	ON_COMMAND(ID_HELP_WINAMPFORUMS, OnMessageID_HELP_WINAMPFORUMS)
	ON_COMMAND(ID_PLAY_VOLUMEUP, OnMessageID_PLAY_VOLUMEUP)
	ON_COMMAND(ID_PLAY_VOLUMEDOWN, OnMessageID_PLAY_VOLUMEDOWN)
	ON_COMMAND(ID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY, OnMessageID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY)
	ON_COMMAND(ID_PEFILE_ADDFROMLIBRARY, OnMessageID_PEFILE_ADDFROMLIBRARY)
	ON_COMMAND(ID_PEFILE_CLOSEPLAYLISTEDITOR, OnMessageID_PEFILE_CLOSEPLAYLISTEDITOR)
	ON_COMMAND(ID_PEPLAYLIST_PLAYLISTPREFERENCES, OnMessageID_PEPLAYLIST_PLAYLISTPREFERENCES)
	ON_COMMAND(ID_MLFILE_NEWPLAYLIST, OnMessageID_MLFILE_NEWPLAYLIST)
	ON_COMMAND(ID_MLFILE_LOADPLAYLIST, OnMessageID_MLFILE_LOADPLAYLIST)
	ON_COMMAND(ID_MLFILE_SAVEPLAYLIST, OnMessageID_MLFILE_SAVEPLAYLIST)
	ON_COMMAND(ID_MLFILE_ADDMEDIATOLIBRARY, OnMessageID_MLFILE_ADDMEDIATOLIBRARY)
	ON_COMMAND(ID_MLFILE_CLOSEMEDIALIBRARY, OnMessageID_MLFILE_CLOSEMEDIALIBRARY)
	ON_COMMAND(ID_MLVIEW_NOWPLAYING, OnMessageID_MLVIEW_NOWPLAYING)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_ALLMEDIA, OnMessageID_MLVIEW_LOCALMEDIA_ALLMEDIA)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_AUDIO, OnMessageID_MLVIEW_LOCALMEDIA_AUDIO)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_VIDEO, OnMessageID_MLVIEW_LOCALMEDIA_VIDEO)
	ON_COMMAND(ID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY, OnMessageID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY)
	ON_COMMAND(ID_MLVIEW_INTERNETRADIO, OnMessageID_MLVIEW_INTERNETRADIO)
	ON_COMMAND(ID_MLVIEW_INTERNETTV, OnMessageID_MLVIEW_INTERNETTV)
	ON_COMMAND(ID_MLVIEW_LIBRARYPREFERENCES, OnMessageID_MLVIEW_LIBRARYPREFERENCES)
	ON_COMMAND(ID_MLVIEW_DEVICES_NOAVAILABLEDEVICE, OnMessageID_MLVIEW_DEVICES_NOAVAILABLEDEVICE)
	ON_COMMAND(ID_MLFILE_IMPORTCURRENTPLAYLIST, OnMessageID_MLFILE_IMPORTCURRENTPLAYLIST)
	ON_COMMAND(ID_MLVIEW_MEDIA, OnMessageID_MLVIEW_MEDIA)
	ON_COMMAND(ID_MLVIEW_PLAYLISTS, OnMessageID_MLVIEW_PLAYLISTS)
	ON_COMMAND(ID_MLVIEW_MEDIA_ALLMEDIA, OnMessageID_MLVIEW_MEDIA_ALLMEDIA)
	ON_COMMAND(ID_MLVIEW_DEVICES, OnMessageID_MLVIEW_DEVICES)
	ON_COMMAND(ID_FILE_SHOWLIBRARY, OnMessageID_FILE_SHOWLIBRARY)
	ON_COMMAND(ID_FILE_CLOSELIBRARY, OnMessageID_FILE_CLOSELIBRARY)
	ON_COMMAND(ID_POST_PLAY_PLAYLIST, OnMessageID_POST_PLAY_PLAYLIST)
	ON_COMMAND(ID_VIS_NEXT, OnMessageID_VIS_NEXT)
	ON_COMMAND(ID_VIS_PREV, OnMessageID_VIS_PREV)
	ON_COMMAND(ID_VIS_RANDOM, OnMessageID_VIS_RANDOM)
	ON_COMMAND(ID_MANAGEPLAYLISTS, OnMessageID_MANAGEPLAYLISTS)
	ON_COMMAND(ID_PREFS_SKIN_SWITCHTOSKIN, OnMessageID_PREFS_SKIN_SWITCHTOSKIN)
	ON_COMMAND(ID_PREFS_SKIN_DELETESKIN, OnMessageID_PREFS_SKIN_DELETESKIN)
	ON_COMMAND(ID_PREFS_SKIN_RENAMESKIN, OnMessageID_PREFS_SKIN_RENAMESKIN)
	ON_COMMAND(ID_VIS_FS, OnMessageID_VIS_FS)
	ON_COMMAND(ID_VIS_CFG, OnMessageID_VIS_CFG)
	ON_COMMAND(ID_VIS_MENU, OnMessageID_VIS_MENU)
	ON_COMMAND(ID_VIS_SET_FS_FLAG, OnMessageID_VIS_SET_FS_FLAG)
	ON_COMMAND(ID_PE_SHOWPLAYING, OnMessageID_PE_SHOWPLAYING)
	ON_COMMAND(ID_HELP_REGISTERWINAMPPRO, OnMessageID_HELP_REGISTERWINAMPPRO)
	ON_COMMAND(ID_PE_MANUAL_ADVANCE, OnMessageID_PE_MANUAL_ADVANCE)
	ON_COMMAND(WA_SONG_5_STAR_RATING, OnMessageWA_SONG_5_STAR_RATING)
	ON_COMMAND(WA_SONG_4_STAR_RATING, OnMessageWA_SONG_4_STAR_RATING)
	ON_COMMAND(WA_SONG_3_STAR_RATING, OnMessageWA_SONG_3_STAR_RATING)
	ON_COMMAND(WA_SONG_2_STAR_RATING, OnMessageWA_SONG_2_STAR_RATING)
	ON_COMMAND(WA_SONG_1_STAR_RATING, OnMessageWA_SONG_1_STAR_RATING)
	ON_COMMAND(WA_SONG_NO_RATING, OnMessageWA_SONG_NO_RATING)
	ON_COMMAND(PL_SONG_5_STAR_RATING, OnMessagePL_SONG_5_STAR_RATING)
	ON_COMMAND(PL_SONG_4_STAR_RATING, OnMessagePL_SONG_4_STAR_RATING)
	ON_COMMAND(PL_SONG_3_STAR_RATING, OnMessagePL_SONG_3_STAR_RATING)
	ON_COMMAND(PL_SONG_2_STAR_RATING, OnMessagePL_SONG_2_STAR_RATING)
	ON_COMMAND(PL_SONG_1_STAR_RATING, OnMessagePL_SONG_1_STAR_RATING)
	ON_COMMAND(PL_SONG_NO_RATING, OnMessagePL_SONG_NO_RATING)
	ON_COMMAND(AUDIO_TRACK_ONE, OnMessageAUDIO_TRACK_ONE)
	ON_COMMAND(VIDEO_TRACK_ONE, OnMessageVIDEO_TRACK_ONE)
	ON_WM_COPYDATA()
END_MESSAGE_MAP()
BOOL CWAEmuWnd::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData)
{
	TRACE(_T("OnCopyData"));
	return TRUE;
}
LRESULT CWAEmuWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	CString filename;
	COPYDATASTRUCT* copyData;
	int index = -1;
	if (this->IsWindowVisible())
	{
		if (pMainFrame->Created)
			if (SeekDialog == NULL || SeekDialog != NULL && SeekDialog->m_hWnd == NULL)
				SeekDialog = SeekDialog->getInstance();
	}
	switch (message)
	{
	case WM_COMMAND:
		TRACE(_T("WM_COMMAND %d %d\n"), wParam, lParam);
		if (lParam == 2)
		{
			/*
            ** If you use SendMessage(hwnd_winamp,WM_COMMAND,MAKEWPARAM(WINAMP_BUTTON2,0),0);
            ** after using IPC_SETPLAYLISTPOS then Winamp will start playing the file at 'position'.
            */
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			return TRUE;
		}
		break;
	case WM_WA_IPC:
		return WAEmuWnd->IamWinamp(message, wParam, lParam);
	case WM_QUIT:
		::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
		return TRUE;
	case WM_PAINT:
		ShowWindow(SW_HIDE);
		if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
			SeekDialog->SaveWindowPosAndDestroy();
		return TRUE;
	case WM_WA_MPEG_EOF:
		TRACE(_T("WM_WA_MPEG_EOF\n"));
		::PostMessage(pMainFrame->m_hWnd, WM_WA_MPEG_EOF, 0, 0);
		return TRUE;
	case IPC_PLAYFILE:
		{
			enqueueFileWithMetaStruct* eFile = (enqueueFileWithMetaStruct*)lParam;
			pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
			TCHAR filenameTCHAR[5000];
			Strcpy(filenameTCHAR, 5000, eFile->filename);
			filename = filenameTCHAR;
			TRACE(_T("IamWinamp IPC_PLAYFILE %s\n"), filename);
			index = m_PlaylistManager.GetIndex(filename);
			if (index == -1)
			{
				m_PlaylistManager.Add(filename);
				index = m_PlaylistManager.GetIndex(filename);
			}
			m_PlaylistManager.Current = index;
			if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			pMainFrame->UpdMBTR();
			return TRUE;
		}
	case IPC_PLAYFILEW:
		{
			enqueueFileWithMetaStructW* eFile = (enqueueFileWithMetaStructW*)lParam;
			pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
			TRACE(_T("IamWinamp IPC_PLAYFILEW %s\n"), eFile->filename);
			index = m_PlaylistManager.GetIndex(eFile->filename);
			if (index == -1)
			{
				m_PlaylistManager.Add(eFile->filename);
				index = m_PlaylistManager.GetIndex(eFile->filename);
			}
			m_PlaylistManager.Current = index;
			if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			pMainFrame->UpdMBTR();
			return TRUE;
		}
	case WM_COPYDATA:
		TRACE(_T("WM_COPYDATA %d %d \n"), wParam, lParam);
		if (!lParam)
			return FALSE;
		copyData = (COPYDATASTRUCT *)lParam;
		switch (copyData->dwData)
		{
		case IPC_PE_INSERTFILENAME:
			{
				fileinfo* fi = (fileinfo*)copyData->lpData;
				TCHAR filenameTCHAR[5000];
				Strcpy(filenameTCHAR, 5000, fi->file);
				int index = m_PlaylistManager.GetIndex(filenameTCHAR);
				CachedTag tmp(filenameTCHAR);
				TCHAR title[5000];
				title[0] = 0;
				int length = 0;
				stdIn->GetFileInfo(filenameTCHAR, title, &length);
				if (wcslen(title) != 0)
				{
					tmp.SetTitle(title);
				}
				else
				{
					tmp.SetTitle(filenameTCHAR);
				}
				tmp.SetDuration(length);
				m_PlaylistManager.Add(tmp, index);
				return TRUE;
			}
		case IPC_PLAYFILE:
			{
				enqueueFileWithMetaStruct* eFile = new enqueueFileWithMetaStruct;
				eFile->filename = (char*)calloc(copyData->cbData + 1, sizeof(char*));
				strcpy((char*)eFile->filename, (char*)copyData->lpData);
				//eFile->filename[copyData->cbData] = 0;
				::SendMessage(WAEmuWnd->m_hWnd, IPC_PLAYFILE, 0, (WPARAM)eFile);
				delete eFile->filename;
				delete eFile;
				break;
			}
		case IPC_PLAYFILEW:
			{
				enqueueFileWithMetaStructW* eFile = new enqueueFileWithMetaStructW;
				eFile->filename = (wchar_t*)calloc(copyData->cbData + 1, sizeof(wchar_t*));
				wcscpy((wchar_t*)eFile->filename, (wchar_t*)copyData->lpData);
				//eFile->filename[copyData->cbData] = 0;
				::SendMessage(WAEmuWnd->m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)eFile);
				delete eFile->filename;
				delete eFile;
				break;
			}
		default:
			break;
		}
		return TRUE;
	}
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

CComPtr<IDispatch> spDisp;

LRESULT CWAEmuWnd::IamWinamp(UINT message, WPARAM wParam, LPARAM lParam)
{
	for (int i = 0; i < registerID.GetSize(); i++)
	{
		UINT tmpRegisterID = IPC_REGISTER_WINAMP_IPCMESSAGE + 2 + i;
		if (tmpRegisterID != 0 && lParam == tmpRegisterID)
		{
			TRACE(_T("IamWinamp RegisterWindowMessage %d %d %d\n"), message, lParam, wParam); 
			genHotkeysAddStruct* hotkeys = (genHotkeysAddStruct*)wParam;
			//			LRESULT ret = PostMessage(tmpRegisterID, wParam, tmpRegisterID);
			//			TRACE(_T("IamWinamp RegisterWindowMessage %d\n"), ret); 	
			return (LRESULT)TRUE;
		}
	}
	switch (lParam)
	{
	case IPC_SETPLAYLISTPOS:
		TRACE(_T("IamWinamp IPC_SETPLAYLISTPOS %d\n"), wParam);
		m_PlaylistManager.Current = wParam;
		return TRUE;
	case IPC_GET_SHUFFLE:
		TRACE(_T("IamWinamp IPC_GET_SHUFFLE\n"));
		return pMainFrame->ShuffleMode;
	case IPC_JUMPTOTIME:
		TRACE(_T("IamWinamp IPC_JUMPTOTIME %d\n"), wParam);
		stdIn->SetOutputTime(wParam);
		return TRUE;
	case IPC_CB_OUTPUTCHANGED:
		TRACE(_T("IamWinamp IPC_CB_OUTPUTCHANGED\n"));
		return TRUE;
	case IPC_GET_IVIDEOOUTPUT:
		TRACE(_T("IamWinamp IPC_GET_IVIDEOOUTPUT\n"));
		vidOut->ShowWindow(SW_NORMAL);
		return (LRESULT)iVidOut;
	case IPC_SETVOLUME:
		if (wParam == -666)
		{
			pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
			return pMainFrame->CurrentVolume;
		}
		else
		{
			pMainFrame->CurrentVolume = wParam;
			pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
			stdIn->SetVolume(pMainFrame->CurrentVolume);
			if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
				SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume * 100 / 255);
		}
		TRACE(_T("IamWinamp IPC_SETVOLUME %d \n"), pMainFrame->CurrentVolume);
		return TRUE;
	case IPC_SETPANNING:
		if (wParam == -666)
			return pMainFrame->CurrentPanning;
		else
		{
			pMainFrame->CurrentPanning = wParam;
			stdIn->SetPan(pMainFrame->CurrentPanning);
		}
		TRACE(_T("IamWinamp IPC_SETPANNING %d \n"), pMainFrame->CurrentPanning);
		return TRUE;
	case IPC_GETINFO:
		TRACE(_T("IamWinamp IPC_GETINFO\n"));
		/* (requires Winamp 2.05+)
        ** int inf=SendMessage(hwnd_winamp,WM_WA_IPC,mode,IPC_GETINFO);
        ** IPC_GETINFO returns info about the current playing song. The value
        ** it returns depends on the value of 'mode'.
        ** Mode 	 Meaning
        ** ------------------
        ** 0		 Samplerate (i.e. 44100)
        ** 1		 Bitrate  (i.e. 128)
        ** 2		 Channels (i.e. 2)
        ** 3 (5+)    Video LOWORD=w HIWORD=h
        ** 4 (5+)    > 65536, string (video description)
        */
		switch (wParam)
		{
		case 0:
			return infoBitrate;
			break;
		case 1:
			return infoSamplerate;
			break;
		case 2:
			return infoStereo; 
			break;
		case 3:
			return MAKEWORD(infoWidth, infoHeight);
			break;
		case 4:
			{
				Strcpy(infoTitleChar, 5000, infoTitle);
				return (LRESULT)infoTitleChar;
				break;
			}
		}
		break;
	case IPC_GET_EXTENDED_FILE_INFO:
		TRACE(_T("IamWinamp IPC_GET_EXTENDED_FILE_INFO\n"));
	case IPC_GET_EXTENDED_FILE_INFO_HOOKABLE:
		{
			extendedFileInfoStruct* eFIS;

			eFIS = (extendedFileInfoStruct *)wParam;
			//			TRACE(_T("IamWinamp IPC_GET_EXTENDED_FILE_INFO_HOOKABLE %s \n"), eFIS->metadata);
			//Analyse du tag demand
			if (!stricmp(eFIS->metadata, "artist"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetArtist(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetArtist(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "title"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetTitle(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetTitle(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "filename"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetFilenameExt(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetFilenameExt(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "album"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetAlbum(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetAlbum(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "comment"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetComment(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetComment(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "genre"))
			{
			}
			else if (!stricmp(eFIS->metadata, "trackno"))
			{
				tmp.Format(_T("%d"), m_PlaylistManager.Current);
				Strcpy(eFIS->ret, 5000, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			else if (!stricmp(eFIS->metadata, "year"))
			{
				Strcpy(eFIS->ret, 5000, m_PlaylistManager.GetYear(m_PlaylistManager.Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetYear(m_PlaylistManager.Current).GetLength();
			}
			else if (!stricmp(eFIS->metadata, "tracknumber"))
			{
				tmp.Format(_T("%.2d"), m_PlaylistManager.Current);
				Strcpy(eFIS->ret, 5000, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
				//Nombre de fois ou on joue la piste
			else if (!stricmp(eFIS->metadata, "playcount"))
			{
				tmp.Format(_T("%d"), 0);
				Strcpy(eFIS->ret, 5000, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			else if (!stricmp(eFIS->metadata, "rating"))
			{
				return NULL;
			}
			else if (!stricmp(eFIS->metadata, "ratingstar"))
			{
				return NULL;
			}
			else
			{
				tmp.Format(_T("%s"), eFIS->metadata);
				Strcpy(eFIS->ret, 5000, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			return (LRESULT)eFIS;
		}
	case IPC_FORMAT_TITLE:
		{
			waFormatTitle* fTitle;

			fTitle = (waFormatTitle *)wParam;
			Strcpy(spec, 5000, fTitle->spec);
			TRACE(_T("IPC_FORMATTITLE %s"), spec);

			tagz_format((const char*)fTitle->spec, ((TAGFUNC)fTitle->TAGFUNC), ((TAGFREEFUNC)fTitle->TAGFREEFUNC), fTitle->p, (char*)fTitle->out, fTitle->out_len);
			Strcpy(out, 5000, fTitle->out);
			TRACE(_T("IPC_FORMATTITLE %s"), out);
			return TRUE;
		}
	case IPC_GETPLAYLISTFILE:
		{
			//TRACE(_T("IamWinamp IPC_GETPLAYLISTFILE %d\n"), wParam);
			Strcpy(playListFile, 5000, m_PlaylistManager.GetPlaylist(wParam));
			return (LRESULT)playListFile;
		}
	case IPC_GETVERSION:
		TRACE(_T("IamWinamp IPC_GETVERSION %d \n"), wParam);
		return 0x5030;
	case IPC_IS_PLAYING_VIDEO:
		TRACE(_T("IamWinamp IPC_IS_PLAYING_VIDEO %d \n"), wParam);
		if (stdIn->GetPlayerMode() == 1)
			return 2;
		else
			return 0;
	case IPC_ISPLAYING:
		return stdIn->GetPlayerMode();
	case IPC_WRITEPLAYLIST:
		TRACE(_T("IamWinamp IPC_WRITEPLAYLIST %d \n"), wParam);
		if (m_PlaylistManager.GetSize() != 0)
		{
			pMainFrame->SaveThePlaylist();
		}
		return m_PlaylistManager.Current;
	case IPC_WRITECONFIG:
		TRACE(_T("IamWinamp IPC_WRITECONFIG %d \n"), wParam);
		switch (wParam)
		{
		case 0:
			pMainFrame->SaveSettings();
			return TRUE;
		case 1:
			pMainFrame->SaveThePlaylist();
			return TRUE;
		case 2:
			pMainFrame->SaveSettings();
			pMainFrame->SaveThePlaylist();
			return TRUE;
		}
	case IPC_GETLISTPOS:
		TRACE(_T("IamWinamp IPC_GETLISTPOS %d\n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return 0;
		return m_PlaylistManager.Current;
	case IPC_GETLISTLENGTH:
		TRACE(_T("IamWinamp IPC_GETLISTLENGTH\n"));
		return m_PlaylistManager.GetSize();
	case IPC_GETEQDATA:
		TRACE(_T("IamWinamp IPC_GETEQDATA %d\n"), wParam);
		if (wParam == 12)
			return 0;
		if (wParam == 11)
			return 0;
		return 31;
	case IPC_GETOUTPUTTIME:
		TRACE(_T("IamWinamp IPC_GETOUTPUTTIME %d \n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return 0;
		if (wParam == 0)
			return stdIn->GetOutputTime();
		else
			return stdIn->GetLength() / 1000;   				
	case IPC_GETPLAYLISTTITLE:
		TRACE(_T("IamWinamp IPC_GETPLAYLISTTITLE %d \n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return (LRESULT)"";
		Strcpy(playListTitle, 5000, m_PlaylistManager.GetTitle(wParam));
		return (LRESULT)playListTitle;
	case WINAMP_OPTIONS_EQ:
		//Equalizer
		TRACE(_T("IamWinamp WINAMP_OPTIONS_EQ %d \n"), wParam);
		if (EqualizerDlg == NULL || EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
			EqualizerDlg = EqualizerDlg->getInstance();
		else if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
			EqualizerDlg->SaveWindowPosAndDestroy();
		return TRUE;
	case WINAMP_MAIN_WINDOW:
		//Minibar
		TRACE(_T("IamWinamp WINAMP_MAIN_WINDOW %d \n"), wParam);
		if (SeekDialog == NULL || SeekDialog != NULL && SeekDialog->m_hWnd == NULL)
			SeekDialog = SeekDialog->getInstance();
		else if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
			SeekDialog->SaveWindowPosAndDestroy();
		return TRUE;
	case WINAMP_FILE_REPEAT:
		//repeat
		TRACE(_T("IamWinamp WINAMP_FILE_REPEAT %d \n"), wParam);
		if (pMainFrame->m_Repeat == 0 && pMainFrame->m_RepeatTrack == 0)
			pMainFrame->m_Repeat = 1;
		else if (pMainFrame->m_Repeat == 1 && pMainFrame->m_RepeatTrack == 0)
		{
			pMainFrame->m_Repeat = 0;
			pMainFrame->m_RepeatTrack = 1;
		}
		else if (pMainFrame->m_Repeat == 0 && pMainFrame->m_RepeatTrack == 1)
			pMainFrame->m_RepeatTrack = 0;
		return TRUE;
	case WINAMP_FILE_SHUFFLE:
		//shuffle
		TRACE(_T("IamWinamp WINAMP_FILE_SHUFFLE %d \n"), wParam);
		if (pMainFrame->ShuffleMode == 1)
			pMainFrame->ShuffleMode = 0;
		else
			pMainFrame->ShuffleMode = 1;
		return TRUE;
	case IPC_REGISTER_WINAMP_IPCMESSAGE:
		{
			Strcpy(descTCHAR, 500, (char*)wParam);
			TRACE(_T("IamWinamp IPC_REGISTER_WINAMP_IPCMESSAGE %s \n"), descTCHAR);
			for (int i = 0; i < registerID.GetSize(); i++)
			{
				if (strcmp(registerID[i], (char*)wParam) == 0)
				{
					TRACE(_T("IamWinamp IPC_REGISTER_WINAMP_IPCMESSAGE %d \n"), 1 + i + IPC_REGISTER_WINAMP_IPCMESSAGE);
					return 2 + i + IPC_REGISTER_WINAMP_IPCMESSAGE;
				}
			}
			if (wParam != NULL)
				registerID.Add((char*)wParam);
			else
				return NULL;
			TRACE(_T("IamWinamp IPC_REGISTER_WINAMP_IPCMESSAGE %d \n"), 1 + registerID.GetSize() + IPC_REGISTER_WINAMP_IPCMESSAGE);
			return 1 + registerID.GetSize() + IPC_REGISTER_WINAMP_IPCMESSAGE;
		}
	case IPC_GETINIFILE:
		TRACE(_T("IamWinamp IPC_GETINIFILE %d \n"), wParam);
		//  		  return (LRESULT) LPCTSTR(pMainFrame->ininame);
		{
			return (LRESULT)szWinampInipath;
		}
	case IPC_GETINIDIRECTORY:
		{
			TRACE(_T("IamWinamp IPC_GETINIDIRECTORY %d \n"), wParam);
			return (LRESULT)szPluginInipath;
		}
	case IPC_ADD_PREFS_DLG:
		{
			TRACE(_T("IamWinamp IPC_ADD_PREFS_DLG \n"));
			prefs = (prefsDlgRec *)wParam;
			listPrefs.SetSize(listPrefs.GetSize() + 1);
			listPrefs[listPrefs.GetSize() - 1] = (CObject *)prefs;
			Strcpy(name, 5000, prefs->name);
			TRACE(_T("IamWinamp IPC_ADD_PREFS_DLG %s %d\n"), name, prefs->dlgID);
			return TRUE;
		}
	case IPC_REMOVE_PREFS_DLG:
		{
			TRACE(_T("IamWinamp IPC_REMOVE_PREFS_DLG %d \n"), wParam);
			prefs = (prefsDlgRec *)wParam;
			for (int i = 0; i < listPrefs.GetSize(); i++)
			{
				prefsDlgRec* prefsComp = (prefsDlgRec*)listPrefs[i];
				if (prefsComp == prefs)
				{
					listPrefs.RemoveAt(i);
					break;
				}
			}
			return TRUE;
		}
	case IPC_GETWND:
		TRACE(_T("IamWinamp IPC_GETWND %d \n"), wParam);
		switch (wParam)
		{
		case IPC_GETWND_EQ:
			break;
		case IPC_GETWND_PE:
			{
				return (LRESULT)PlaylistDlg->m_hWnd;
			}
		case IPC_GETWND_MB:
			break;
		case IPC_GETWND_VIDEO:
			break;
		}

		return (LRESULT)NULL;
	case IPC_GET_EMBEDIF:
		{
			TRACE(_T("IamWinamp IPC_GET_EMBEDIF %d \n"), wParam);
			if (wParam == NULL)
				return (LRESULT)&eWindow;
			CWinampWnd* myWnd = new CWinampWnd(this);
			listWnd.Add(myWnd);
			//Wnd			myWnd.Create(_T("STPAppChildClass"), "Hi", WS_CHILD | WS_VISIBLE,
			//				CRect(0, 0, 200, 200), WAEmuWnd, 1234);
			//myWnd.CreateEx(WS_EX_TRANSPARENT, _T("STPAppChildClass"), "STPAppChildClass", WS_POPUP|WS_OVERLAPPEDWINDOW|WS_DLGFRAME, 0, 0, ::GetSystemMetrics(SM_CXFULLSCREEN), ::GetSystemMetrics(SM_CYFULLSCREEN), WAEmuWnd->m_hWnd, NULL, NULL);
			myWnd->Create(WAEmuWnd);

			return (LRESULT)myWnd->m_hWnd;
		}
	case IPC_GETUNCOMPRESSINTERFACE:
		TRACE(_T("IamWinamp IPC_GETUNCOMPRESSINTERFACE %d \n"), wParam);
		return (LRESULT)uncompress;
	case IPC_ISWNDVISIBLE:
		TRACE(_T("IamWinamp IPC_ISWNDVISIBLE %d \n"), wParam);
		return IsWindowVisible();
	case IPC_UPDTITLE:
		{
			TRACE(_T("IPC_UPDTITLE %d"), wParam);
			title[0] = 0;
			stdIn->GetFileInfo(NULL, (TCHAR *)&title, &length_in_ms);
			CString strTitle;
			strTitle.Format(_T("%s"), title);
			CString filename = m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current);
			if (stdIn->IsOurFile((TCHAR *)m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current).GetString()))
			{
				CString strComment = filename;
				CString strArtist = "";
				if (strTitle.Find(_T(" - ")) > 0 && strTitle.Find(_T(" - ")) < strTitle.ReverseFind('(') && strTitle.ReverseFind('(') > 0)
				{
					strArtist = strTitle.Left(strTitle.Find(_T(" - ")));
					strTitle = strTitle.Right(strTitle.GetLength() - strTitle.Find(_T(" - ")) - 3);
					strComment = strTitle.Right(strTitle.GetLength() - strTitle.Find('(') - 1);
					strTitle = strTitle.Left(strTitle.Find('(') - 1);
					if (strComment.Find(')') < strComment.Find('('))
					{
						strComment = strComment.Left(strComment.Find(')'));
					}
					else
					{
						strComment = strComment.Left(strComment.ReverseFind(')'));
					}
				}
				m_PlaylistManager.SetComment(m_PlaylistManager.Current, strComment);
				m_PlaylistManager.SetArtist(m_PlaylistManager.Current, strArtist);
				m_PlaylistManager.SetTitle(m_PlaylistManager.Current, strTitle);
				if (!pMainFrame->m_traytip.IsVisible())
					pMainFrame->DisplayTooltip();
			}
			else
			{
				if (strTitle.GetLength() != 0)
				{
					m_PlaylistManager.SetTitle(m_PlaylistManager.Current, strTitle);
				}
				else
				{
					m_PlaylistManager.SetTitle(m_PlaylistManager.Current, m_PlaylistManager.GetFilename(m_PlaylistManager.Current));
				}
			}
			m_PlaylistManager.SetDuration(m_PlaylistManager.Current, length_in_ms);
			return TRUE;
		}
	case IPC_OPENPREFSTOPAGE:
		TRACE(_T("IPC_OPENPREFSTOPAGE %d"), wParam);
		if (SettingsDialog == NULL || SettingsDialog != NULL && SettingsDialog->m_hWnd == NULL)
			SettingsDialog = SettingsDialog->getInstance();
		if (!SettingsDialog->IsWindowVisible())
			SettingsDialog->ShowWindow(SW_SHOW);
		if (wParam < 200)
			SettingsDialog->SetActivePage((int)wParam);
		else
			SettingsDialog->SetActivePage((prefsDlgRec *)wParam);
		return TRUE;
	case IPC_GET_EXTLIST:
		TRACE(_T("IPC_GET_EXTLIST %d"), wParam);
		extList = (char*)GlobalAlloc(GMEM_FIXED, 5000);
		tmp = stdIn->GetFileExtensions();
		tmp.MakeLower();
		Strcpy(extList, 5000, tmp.GetString());
		for (int i = 0; i < 5000; i++)
		{
			if (extList[i] == ';')
				extList[i] = 0;
		}
		return (LRESULT)extList;
	case IPC_IS_FULLSCREEN:
		TRACE(_T("IamWinamp IPC_IS_FULLSCREEN %d \n"), wParam);
		return FALSE;
	case IPC_GET_GENSKINBITMAP:
		{
			TRACE(_T("IamWinamp IPC_GET_GENSKINBITMAP %d \n"), wParam);
			switch (wParam)
			{
			case 1:
				return (LRESULT)TEXT("Verdana");
			case 2:
				return DEFAULT_CHARSET;
			case 3:
				return 9;
			default:
				return (LRESULT)image;
			}
		}
	case IPC_GETSKIN:
		{
			TRACE(_T("IamWinamp IPC_GETSKIN \n"));
			p = (char*)wParam;
			CFileFind finder;
			if (!finder.FindFile(pathGen))
			{
				HANDLE hFile = CreateFileA(szPathGen, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				HRSRC hRes = (HRSRC)::FindResource(theApp.m_hInstance, MAKEINTRESOURCE(IDB_GEN), _T("IMAGE"));

				// loads the specified resource into global memory. 
				HGLOBAL hResourceLoaded = ::LoadResource(theApp.m_hInstance, hRes); 

				// get a pointer to the loaded resource!
				char* lpResLock;				// pointer to resource data 
				lpResLock = (char*)LockResource(hResourceLoaded); 

				DWORD dwWriteSize, dwNumWritten;
				// determine the size of the resource, so we know how much to write out to file!  
				dwWriteSize = ::SizeofResource(theApp.m_hInstance, hRes);
				WriteFile(hFile, (const char*)lpResLock, dwWriteSize, &dwNumWritten, NULL); 
				CloseHandle(hFile);
			}
			strcpy(p, szPath);
			return TRUE;
		}
	case IPC_GET_PROXY_STRING:
		TRACE(_T("IamWinamp IPC_GET_PROXY_STRING %s \n"), wParam);
		return (LRESULT)"";
	case IPC_GET_API_SERVICE:
		TRACE(_T("IamWinamp IPC_GET_API_SERVICE \n"));
		return (LRESULT)&service;
	case IPC_GET_RANDFUNC:
		TRACE(_T("IamWinamp IPC_GET_RANDFUNC %d \n"), wParam);
		return (LRESULT)(int(*)(void))rand();
	case IPC_GET_DISPATCH_OBJECT:
		{
			TRACE(_T("IamWinamp IPC_GET_DISPATCH_OBJECT %d \n"), wParam);
			//			spDisp = new HTMLContainer(this->m_hWnd);
			return (LRESULT &)spDisp;
		}
	case IPC_DELETE:
		{
			TRACE(_T("IamWinamp IPC_DELETE \n"));
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			m_PlaylistManager.RemoveAll();
			if (PlaylistDlg->IsWindowVisible())
				PlaylistDlg->FillPlaylist();
			return TRUE;
		}
	case IPC_STARTPLAY:
	case IPC_STARTPLAY_INT:
		{
			TRACE(_T("IamWinamp IPC_STARTPLAY \n"));
			if (stdIn->GetPlayerMode() != PLAYER_MODE_PLAYING)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			return TRUE;
		}
	case IPC_GET_HMENU:
		{
			TRACE(_T("IamWinamp IPC_GET_HMENU %d\n"), wParam);
			switch (wParam)
			{
				// 0 : main popup menu 
			case 0:
				return (LRESULT)pMainFrame->mainMenu.m_hMenu;

				// 1 : main menubar file menu
				// 2 : main menubar options menu
				// 3 : main menubar windows menu
				// 4 : main menubar help menu
			default:
				return NULL;
			}
		}
	default:
		TRACE(_T("Message non reu %d %d\n"), wParam, lParam);
	}
	return CFrameWnd::DefWindowProc(WM_WA_IPC, wParam, lParam);
}



void CWAEmuWnd::OnMessageWINAMP_FILE_QUIT()
{
	TRACE(_T("Command WINAMP_FILE_QUIT"));
	pMainFrame->Finish();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_PREFS()
{
	TRACE(_T("Command WINAMP_OPTIONS_PREFS"));
	SettingsDialog->getInstance();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_AOT()
{
	TRACE(_T("Command WINAMP_OPTIONS_AOT"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_REPEAT()
{
	TRACE(_T("Command WINAMP_FILE_REPEAT"));
	if (pMainFrame->m_RepeatTrack == 1)
		pMainFrame->m_RepeatTrack = 0;
	else
	{
		pMainFrame->m_RepeatTrack = 1;pMainFrame->m_Repeat = 0;
	}
}
void CWAEmuWnd::OnMessageWINAMP_FILE_SHUFFLE()
{
	TRACE(_T("Command WINAMP_FILE_SHUFFLE"));
	if (pMainFrame->ShuffleMode == 1)
		pMainFrame->ShuffleMode = 0;
	else
		pMainFrame->ShuffleMode = 1;
}
void CWAEmuWnd::OnMessageWINAMP_HIGH_PRIORITY()
{
	TRACE(_T("Command WINAMP_HIGH_PRIORITY"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_PLAY()
{
	TRACE(_T("Command WINAMP_FILE_PLAY"));
	if (pMainFrame->opening)
		return;
	pMainFrame->opening = true;
	//open a file

	CFileDialog dialog(TRUE, _T("mp3"), _T(""), OFN_ALLOWMULTISELECT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, stdIn->GetFileExtensionsFilter());
	TCHAR buffer[_MAX_PATH*500 + 1];
	buffer[0] = '\0';
	dialog.m_ofn.lpstrFile = buffer;
	dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
	dialog.m_ofn.lpstrInitialDir = LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK)
	{
		POSITION p = dialog.GetStartPosition();
		CString buf;
		bool q = false;
		while (p != NULL)
		{
			buf = dialog.GetNextPathName(p);
			pMainFrame->InitDir = buf.Left(buf.ReverseFind('\\') + 1);
			if ((buf.Right(4)).CompareNoCase(_T(".M3U")) == 0 || (buf.Right(4)).CompareNoCase(_T(".PLS")) == 0)
			{
				//a playlist was selected
				pMainFrame->OpenPlaylist(buf, (pMainFrame->RandomFirst == 1), (q == 1));
			}
			else
			{
				//a file was selected
				pMainFrame->OpenFile(buf, (q == 1));
			}
			pMainFrame->AddRecent(buf);
			q = true;
		}
	}
	pMainFrame->opening = false;
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_EQ"));
	if (EqualizerDlg == NULL || EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
		EqualizerDlg = EqualizerDlg->getInstance();
	else if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
		EqualizerDlg->SaveWindowPosAndDestroy();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_ELAPSED()
{
	TRACE(_T("Command WINAMP_OPTIONS_ELAPSED"));
	pMainFrame->ShowRemainingTime = 0;     
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_REMAINING()
{
	TRACE(_T("Command WINAMP_OPTIONS_REMAINING"));
	pMainFrame->ShowRemainingTime = 1;
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_PLEDIT()
{
	TRACE(_T("Command WINAMP_OPTIONS_PLEDIT"));
	if (!PlaylistDlg->IsWindowVisible())
		PlaylistDlg->ShowWindow(SW_SHOW);
	else
		PlaylistDlg->SaveWindowPosAndDestroy();
}
void CWAEmuWnd::OnMessageWINAMP_HELP_ABOUT()
{
	TRACE(_T("Command WINAMP_HELP_ABOUT"));
	AboutDialog = AboutDialog->getInstance();
}
void CWAEmuWnd::OnMessageWINAMP_MAINMENU()
{
	TRACE(_T("Command WINAMP_MAINMENU"));
	pMainFrame->ShowPopup(1);
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1()
{
	TRACE(_T("Command WINAMP_BUTTON1 OK"));
	//prev
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
	if (m_PlaylistManager.GetSize() < 2)
		return;
	if (pMainFrame->ShuffleMode)
		m_PlaylistManager.Current = pMainFrame->MyRandom(false);
	else
	{
		int b, e; 
		pMainFrame->GetAlbumRange(&b, &e);
		if (m_PlaylistManager.Current == b)
			m_PlaylistManager.Current = e;
		else
			m_PlaylistManager.Current--;
	}
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);

	pMainFrame->UpdMBTR();
	if (PlaylistDlg->IsWindowVisible())
		PlaylistDlg->m_playlistat.Invalidate();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2()
{
	TRACE(_T("Command WINAMP_BUTTON2 OK"));
	//play
	if (m_PlaylistManager.GetSize() != 0)
		switch (stdIn->GetPlayerMode())
		{
		case PLAYER_MODE_CLOSE :
			pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
			stdIn->SetOutMod(stdOut->GetOut_Module());
			stdIn->SetVolume(pMainFrame->CurrentVolume);
			if (m_PlaylistManager.GetExt(m_PlaylistManager.Current).MakeLower().Find(_T(".m3u")) == 0)
			{
				CString playlist = m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current);
				m_PlaylistManager.RemoveAt(m_PlaylistManager.Current);
				pMainFrame->OpenPlaylistEngine(playlist, false, true, true);
				return;
			}
			else
			{
				stdIn->Play((TCHAR *)m_PlaylistManager.GetPlaylist(m_PlaylistManager.Current).GetString());
			}
			stdIn->SetVolume(pMainFrame->CurrentVolume);
			pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
			if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
				SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume * 100 / 255);
			break;
		case PLAYER_MODE_PAUSED :
			stdIn->UnPause();
			break;
		case PLAYER_MODE_PLAYING :
			stdIn->Pause();
			break;
		}
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3()
{
	TRACE(_T("Command WINAMP_BUTTON3 OK"));
	//pause
	if (m_PlaylistManager.GetSize() != 0)
		switch (stdIn->GetPlayerMode())
		{
		case PLAYER_MODE_CLOSE :
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			break;
		case PLAYER_MODE_PAUSED :
			stdIn->UnPause();
			break;
		case PLAYER_MODE_PLAYING :
			stdIn->Pause();
			break;
		}
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4()
{
	TRACE(_T("Command WINAMP_BUTTON4 OK"));
	//stop
	if (m_PlaylistManager.GetSize() == 0)
		return;
	if (stdIn->GetPlayerMode() != PLAYER_MODE_CLOSE)
		stdIn->Stop();
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5()
{
	TRACE(_T("Command WINAMP_BUTTON5 OK"));
	//next

	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);

	if (pMainFrame->ShuffleMode)
	{
		m_PlaylistManager.Current = pMainFrame->MyRandom(true);
		if (m_PlaylistManager.Current == pMainFrame->FirstInMyRandom && pMainFrame->m_Repeat != 1)
		{
			if (pMainFrame->TryToEnd())
				return;
		}
	}
	else
	{
		int b, e; 
		pMainFrame->GetAlbumRange(&b, &e);
		if (m_PlaylistManager.Current == e)
		{
			m_PlaylistManager.Current = b;
			if (pMainFrame->m_Repeat != 1)
			{
				if (pMainFrame->TryToEnd())
					return;
			}
		}
		else
			m_PlaylistManager.Current++;
	}
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);

	pMainFrame->UpdMBTR();
	if (PlaylistDlg->IsWindowVisible())
		PlaylistDlg->m_playlistat.Invalidate();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1_SHIFT()
{
	//5 sec backward
	TRACE(_T("Command WINAMP_BUTTON1_SHIFT"));
	if (m_PlaylistManager.GetSize() > 0 && stdIn->isSeekable())
		stdIn->SetOutputTime(stdIn->GetOutputTime() - 5);
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON2_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON3_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON4_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5_SHIFT()
{
	//5 sec forward
	TRACE(_T("Command WINAMP_BUTTON5_SHIFT"));
	if (m_PlaylistManager.GetSize() > 0 && stdIn->isSeekable())
		stdIn->SetOutputTime(stdIn->GetOutputTime() + 5);
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON1_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2_CTRL()
{
	//open URL
	TRACE(_T("Command WINAMP_BUTTON2_CTRL"));
	pMainFrame->OnPopupMenuOpenUrl();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON3_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON4_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON5_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_VOLUMEUP()
{
	TRACE(_T("Command WINAMP_VOLUMEUP OK"));
	//vol up
	pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
	pMainFrame->CurrentVolume += 5;
	if (pMainFrame->CurrentVolume > 255)
		pMainFrame->CurrentVolume = 255;
	pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
	stdIn->SetVolume(pMainFrame->CurrentVolume);
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
		SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume * 100 / 255);
}
void CWAEmuWnd::OnMessageWINAMP_VOLUMEDOWN()
{
	TRACE(_T("Command WINAMP_VOLUMEDOWN OK"));
	//vol down
	pMainFrame->CurrentVolume = pVolume.GetCurrentVolume();
	pMainFrame->CurrentVolume -= 5;
	if (pMainFrame->CurrentVolume < 0)
		pMainFrame->CurrentVolume = 0;
	pVolume.SetCurrentVolume(pMainFrame->CurrentVolume);
	stdIn->SetVolume(pMainFrame->CurrentVolume);
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
		SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume * 100 / 255);
}
void CWAEmuWnd::OnMessageWINAMP_FFWD5S()
{
	TRACE(_T("Command WINAMP_FFWD5S"));
}
void CWAEmuWnd::OnMessageWINAMP_REW5S()
{
	TRACE(_T("Command WINAMP_REW5S"));
}
void CWAEmuWnd::OnMessageWINAMP_NEXT_WINDOW()
{
	TRACE(_T("Command WINAMP_NEXT_WINDOW"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_DSIZE()
{
	TRACE(_T("Command WINAMP_OPTIONS_DSIZE"));
}
void CWAEmuWnd::OnMessageIDC_SORT_FILENAME()
{
	TRACE(_T("Command IDC_SORT_FILENAME"));
}
void CWAEmuWnd::OnMessageIDC_SORT_FILETITLE()
{
	TRACE(_T("Command IDC_SORT_FILETITLE"));
}
void CWAEmuWnd::OnMessageIDC_SORT_ENTIREFILENAME()
{
	TRACE(_T("Command IDC_SORT_ENTIREFILENAME"));
}
void CWAEmuWnd::OnMessageIDC_SELECTALL()
{
	TRACE(_T("Command IDC_SELECTALL"));
}
void CWAEmuWnd::OnMessageIDC_SELECTNONE()
{
	TRACE(_T("Command IDC_SELECTNONE"));
}
void CWAEmuWnd::OnMessageIDC_SELECTINV()
{
	TRACE(_T("Command IDC_SELECTINV"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADPRE()
{
	TRACE(_T("Command IDM_EQ_LOADPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADMP3()
{
	TRACE(_T("Command IDM_EQ_LOADMP3"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADDEFAULT()
{
	TRACE(_T("Command IDM_EQ_LOADDEFAULT"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEPRE()
{
	TRACE(_T("Command IDM_EQ_SAVEPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEMP3()
{
	TRACE(_T("Command IDM_EQ_SAVEMP3"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEDEFAULT()
{
	TRACE(_T("Command IDM_EQ_SAVEDEFAULT"));
}
void CWAEmuWnd::OnMessageIDM_EQ_DELPRE()
{
	TRACE(_T("Command IDM_EQ_DELPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_DELMP3()
{
	TRACE(_T("Command IDM_EQ_DELMP3"));
}
void CWAEmuWnd::OnMessageIDC_PLAYLIST_PLAY()
{
	TRACE(_T("Command IDC_PLAYLIST_PLAY"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_LOC()
{
	TRACE(_T("Command WINAMP_FILE_LOC"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EASYMOVE()
{
	TRACE(_T("Command WINAMP_OPTIONS_EASYMOVE"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_DIR()
{
	TRACE(_T("Command WINAMP_FILE_DIR"));
}
void CWAEmuWnd::OnMessageWINAMP_EDIT_ID3()
{
	TRACE(_T("Command WINAMP_EDIT_ID3"));
}
void CWAEmuWnd::OnMessageWINAMP_TOGGLE_AUTOSCROLL()
{
	TRACE(_T("Command WINAMP_TOGGLE_AUTOSCROLL"));
}
void CWAEmuWnd::OnMessageWINAMP_VISSETUP()
{
	TRACE(_T("Command WINAMP_VISSETUP"));
}
void CWAEmuWnd::OnMessageWINAMP_PLGSETUP()
{
	TRACE(_T("Command WINAMP_PLGSETUP"));
}
void CWAEmuWnd::OnMessageWINAMP_VISPLUGIN()
{
	TRACE(_T("Command WINAMP_VISPLUGIN"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMP()
{
	TRACE(_T("Command WINAMP_JUMP"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMPFILE()
{
	TRACE(_T("Command WINAMP_JUMPFILE"));
	if (!PlaylistDlg->IsWindowVisible())
		PlaylistDlg->ShowWindow(SW_SHOW);
}
void CWAEmuWnd::OnMessageWINAMP_JUMP10FWD()
{
	TRACE(_T("Command WINAMP_JUMP10FWD"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMP10BACK()
{
	TRACE(_T("Command WINAMP_JUMP10BACK"));
}
void CWAEmuWnd::OnMessageWINAMP_PREVSONG()
{
	TRACE(_T("Command WINAMP_PREVSONG"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EXTRAHQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_EXTRAHQ"));
}
void CWAEmuWnd::OnMessageID_PE_NEW()
{
	TRACE(_T("Command ID_PE_NEW"));
}
void CWAEmuWnd::OnMessageID_PE_OPEN()
{
	TRACE(_T("Command ID_PE_OPEN"));
}
void CWAEmuWnd::OnMessageID_PE_SAVE()
{
	TRACE(_T("Command ID_PE_SAVE"));
}
void CWAEmuWnd::OnMessageID_PE_SAVEAS()
{
	TRACE(_T("Command ID_PE_SAVEAS"));
}
void CWAEmuWnd::OnMessageID_PE_SELECTALL()
{
	TRACE(_T("Command ID_PE_SELECTALL"));
}
void CWAEmuWnd::OnMessageID_PE_INVERT()
{
	TRACE(_T("Command ID_PE_INVERT"));
}
void CWAEmuWnd::OnMessageID_PE_NONE()
{
	TRACE(_T("Command ID_PE_NONE"));
}
void CWAEmuWnd::OnMessageID_PE_ID3()
{
	TRACE(_T("Command ID_PE_ID3"));
}
void CWAEmuWnd::OnMessageID_PE_S_TITLE()
{
	TRACE(_T("Command ID_PE_S_TITLE"));
}
void CWAEmuWnd::OnMessageID_PE_S_FILENAME()
{
	TRACE(_T("Command ID_PE_S_FILENAME"));
}
void CWAEmuWnd::OnMessageID_PE_S_PATH()
{
	TRACE(_T("Command ID_PE_S_PATH"));
}
void CWAEmuWnd::OnMessageID_PE_S_RANDOM()
{
	TRACE(_T("Command ID_PE_S_RANDOM"));
}
void CWAEmuWnd::OnMessageID_PE_S_REV()
{
	TRACE(_T("Command ID_PE_S_REV"));
}
void CWAEmuWnd::OnMessageID_PE_CLEAR()
{
	TRACE(_T("Command ID_PE_CLEAR"));
}
void CWAEmuWnd::OnMessageID_PE_MOVEUP()
{
	TRACE(_T("Command ID_PE_MOVEUP"));
}
void CWAEmuWnd::OnMessageID_PE_MOVEDOWN()
{
	TRACE(_T("Command ID_PE_MOVEDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_SELSKIN()
{
	TRACE(_T("Command WINAMP_SELSKIN"));
}
void CWAEmuWnd::OnMessageWINAMP_VISCONF()
{
	TRACE(_T("Command WINAMP_VISCONF"));
}
void CWAEmuWnd::OnMessageID_PE_NONEXIST()
{
	TRACE(_T("Command ID_PE_NONEXIST"));
}
void CWAEmuWnd::OnMessageID_PE_DELETEFROMDISK()
{
	TRACE(_T("Command ID_PE_DELETEFROMDISK"));
}
void CWAEmuWnd::OnMessageID_PE_CLOSE()
{
	TRACE(_T("Command ID_PE_CLOSE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETOSC()
{
	TRACE(_T("Command WINAMP_VIS_SETOSC"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETANA()
{
	TRACE(_T("Command WINAMP_VIS_SETANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETOFF()
{
	TRACE(_T("Command WINAMP_VIS_SETOFF"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_DOTSCOPE()
{
	TRACE(_T("Command WINAMP_VIS_DOTSCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LINESCOPE()
{
	TRACE(_T("Command WINAMP_VIS_LINESCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SOLIDSCOPE()
{
	TRACE(_T("Command WINAMP_VIS_SOLIDSCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_NORMANA()
{
	TRACE(_T("Command WINAMP_VIS_NORMANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FIREANA()
{
	TRACE(_T("Command WINAMP_VIS_FIREANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LINEANA()
{
	TRACE(_T("Command WINAMP_VIS_LINEANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_NORMVU()
{
	TRACE(_T("Command WINAMP_VIS_NORMVU"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SMOOTHVU()
{
	TRACE(_T("Command WINAMP_VIS_SMOOTHVU"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF2()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF3()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF4()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF4"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_TOGTIME()
{
	TRACE(_T("Command WINAMP_OPTIONS_TOGTIME"));
}
void CWAEmuWnd::OnMessageEQ_ENABLE()
{
	TRACE(_T("Command EQ_ENABLE"));
}
void CWAEmuWnd::OnMessageEQ_AUTO()
{
	TRACE(_T("Command EQ_AUTO"));
}
void CWAEmuWnd::OnMessageEQ_PRESETS()
{
	TRACE(_T("Command EQ_PRESETS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF0()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF0"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF1()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF1"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF2()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF2"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF3()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF4()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF4"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PEAKS()
{
	TRACE(_T("Command WINAMP_VIS_PEAKS"));
}
void CWAEmuWnd::OnMessageID_LOAD_EQF()
{
	TRACE(_T("Command ID_LOAD_EQF"));
}
void CWAEmuWnd::OnMessageID_SAVE_EQF()
{
	TRACE(_T("Command ID_SAVE_EQF"));
}
void CWAEmuWnd::OnMessageID_PE_ENTRY()
{
	TRACE(_T("Command ID_PE_ENTRY"));
}
void CWAEmuWnd::OnMessageID_PE_SCROLLUP()
{
	TRACE(_T("Command ID_PE_SCROLLUP"));
}
void CWAEmuWnd::OnMessageID_PE_SCROLLDOWN()
{
	TRACE(_T("Command ID_PE_SCROLLDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_MAIN_WINDOW()
{
	TRACE(_T("Command WINAMP_MAIN_WINDOW"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF0()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF0"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF1()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF1"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF2()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF2"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF3()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF4()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF4"));
}
void CWAEmuWnd::OnMessageID_PE_TOP()
{
	TRACE(_T("Command ID_PE_TOP"));
}
void CWAEmuWnd::OnMessageID_PE_BOTTOM()
{
	TRACE(_T("Command ID_PE_BOTTOM"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE_PL()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE_PL"));
}
void CWAEmuWnd::OnMessageEQ_INC1()
{
	TRACE(_T("Command EQ_INC1"));
}
void CWAEmuWnd::OnMessageEQ_INC2()
{
	TRACE(_T("Command EQ_INC2"));
}
void CWAEmuWnd::OnMessageEQ_INC3()
{
	TRACE(_T("Command EQ_INC3"));
}
void CWAEmuWnd::OnMessageEQ_INC4()
{
	TRACE(_T("Command EQ_INC4"));
}
void CWAEmuWnd::OnMessageEQ_INC5()
{
	TRACE(_T("Command EQ_INC5"));
}
void CWAEmuWnd::OnMessageEQ_INC6()
{
	TRACE(_T("Command EQ_INC6"));
}
void CWAEmuWnd::OnMessageEQ_INC7()
{
	TRACE(_T("Command EQ_INC7"));
}
void CWAEmuWnd::OnMessageEQ_INC8()
{
	TRACE(_T("Command EQ_INC8"));
}
void CWAEmuWnd::OnMessageEQ_INC9()
{
	TRACE(_T("Command EQ_INC9"));
}
void CWAEmuWnd::OnMessageEQ_INC10()
{
	TRACE(_T("Command EQ_INC10"));
}
void CWAEmuWnd::OnMessageEQ_INCPRE()
{
	TRACE(_T("Command EQ_INCPRE"));
}
void CWAEmuWnd::OnMessageEQ_DECPRE()
{
	TRACE(_T("Command EQ_DECPRE"));
}
void CWAEmuWnd::OnMessageEQ_DEC1()
{
	TRACE(_T("Command EQ_DEC1"));
}
void CWAEmuWnd::OnMessageEQ_DEC2()
{
	TRACE(_T("Command EQ_DEC2"));
}
void CWAEmuWnd::OnMessageEQ_DEC3()
{
	TRACE(_T("Command EQ_DEC3"));
}
void CWAEmuWnd::OnMessageEQ_DEC4()
{
	TRACE(_T("Command EQ_DEC4"));
}
void CWAEmuWnd::OnMessageEQ_DEC5()
{
	TRACE(_T("Command EQ_DEC5"));
}
void CWAEmuWnd::OnMessageEQ_DEC6()
{
	TRACE(_T("Command EQ_DEC6"));
}
void CWAEmuWnd::OnMessageEQ_DEC7()
{
	TRACE(_T("Command EQ_DEC7"));
}
void CWAEmuWnd::OnMessageEQ_DEC8()
{
	TRACE(_T("Command EQ_DEC8"));
}
void CWAEmuWnd::OnMessageEQ_DEC9()
{
	TRACE(_T("Command EQ_DEC9"));
}
void CWAEmuWnd::OnMessageEQ_DEC10()
{
	TRACE(_T("Command EQ_DEC10"));
}
void CWAEmuWnd::OnMessageID_PE_SCUP()
{
	TRACE(_T("Command ID_PE_SCUP"));
}
void CWAEmuWnd::OnMessageID_PE_SCDOWN()
{
	TRACE(_T("Command ID_PE_SCDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_REFRESHSKIN()
{
	TRACE(_T("Command WINAMP_REFRESHSKIN"));
}
void CWAEmuWnd::OnMessageID_PE_PRINT()
{
	TRACE(_T("Command ID_PE_PRINT"));
}
void CWAEmuWnd::OnMessageID_PE_EXTINFO()
{
	TRACE(_T("Command ID_PE_EXTINFO"));
}
void CWAEmuWnd::OnMessageWINAMP_PLAYLIST_ADVANCE()
{
	TRACE(_T("Command WINAMP_PLAYLIST_ADVANCE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LIN()
{
	TRACE(_T("Command WINAMP_VIS_LIN"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_BAR()
{
	TRACE(_T("Command WINAMP_VIS_BAR"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_MINIBROWSER()
{
	TRACE(_T("Command WINAMP_OPTIONS_MINIBROWSER"));
}
void CWAEmuWnd::OnMessageMB_FWD()
{
	TRACE(_T("Command MB_FWD"));
}
void CWAEmuWnd::OnMessageMB_BACK()
{
	TRACE(_T("Command MB_BACK"));
}
void CWAEmuWnd::OnMessageMB_RELOAD()
{
	TRACE(_T("Command MB_RELOAD"));
}
void CWAEmuWnd::OnMessageMB_OPENMENU()
{
	TRACE(_T("Command MB_OPENMENU"));
}
void CWAEmuWnd::OnMessageMB_OPENLOC()
{
	TRACE(_T("Command MB_OPENLOC"));
}
void CWAEmuWnd::OnMessageWINAMP_NEW_INSTANCE()
{
	TRACE(_T("Command WINAMP_NEW_INSTANCE"));
}
void CWAEmuWnd::OnMessageMB_UPDATE()
{
	TRACE(_T("Command MB_UPDATE"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE_EQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE_EQ"));
}
void CWAEmuWnd::OnMessageEQ_PANLEFT()
{
	TRACE(_T("Command EQ_PANLEFT"));
}
void CWAEmuWnd::OnMessageEQ_PANRIGHT()
{
	TRACE(_T("Command EQ_PANRIGHT"));
}
void CWAEmuWnd::OnMessageWINAMP_GETMORESKINS()
{
	TRACE(_T("Command WINAMP_GETMORESKINS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_OPTIONS()
{
	TRACE(_T("Command WINAMP_VIS_OPTIONS"));
}
void CWAEmuWnd::OnMessageWINAMP_PE_SEARCH()
{
	TRACE(_T("Command WINAMP_PE_SEARCH"));
}
void CWAEmuWnd::OnMessageID_PE_BOOKMARK()
{
	TRACE(_T("Command ID_PE_BOOKMARK"));
}
void CWAEmuWnd::OnMessageWINAMP_EDIT_BOOKMARKS()
{
	TRACE(_T("Command WINAMP_EDIT_BOOKMARKS"));
}
void CWAEmuWnd::OnMessageWINAMP_MAKECURBOOKMARK()
{
	TRACE(_T("Command WINAMP_MAKECURBOOKMARK"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_BOOKMARK_NONE()
{
	TRACE(_T("Command ID_MAIN_PLAY_BOOKMARK_NONE"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD2()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD2"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD3()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD3"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD4()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD4"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_VIDEO()
{
	TRACE(_T("Command WINAMP_OPTIONS_VIDEO"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOMFULLSCREEN()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOMFULLSCREEN"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM100()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM100"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM200()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM200"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM50()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM50"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_VIDEOOPTIONS()
{
	TRACE(_T("Command ID_VIDEOWND_VIDEOOPTIONS"));
}
void CWAEmuWnd::OnMessageWINAMP_MINIMIZE()
{
	TRACE(_T("Command WINAMP_MINIMIZE"));
}
void CWAEmuWnd::OnMessageID_PE_FONTBIGGER()
{
	TRACE(_T("Command ID_PE_FONTBIGGER"));
}
void CWAEmuWnd::OnMessageID_PE_FONTSMALLER()
{
	TRACE(_T("Command ID_PE_FONTSMALLER"));
}
void CWAEmuWnd::OnMessageWINAMP_VIDEO_TOGGLE_FS()
{
	TRACE(_T("Command WINAMP_VIDEO_TOGGLE_FS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIDEO_TVBUTTON()
{
	TRACE(_T("Command WINAMP_VIDEO_TVBUTTON"));
}
void CWAEmuWnd::OnMessageWINAMP_LIGHTNING_CLICK()
{
	TRACE(_T("Command WINAMP_LIGHTNING_CLICK"));
}
void CWAEmuWnd::OnMessageID_FILE_ADDTOLIBRARY()
{
	TRACE(_T("Command ID_FILE_ADDTOLIBRARY"));
}
void CWAEmuWnd::OnMessageID_HELP_HELPTOPICS()
{
	TRACE(_T("Command ID_HELP_HELPTOPICS"));
}
void CWAEmuWnd::OnMessageID_HELP_GETTINGSTARTED()
{
	TRACE(_T("Command ID_HELP_GETTINGSTARTED"));
}
void CWAEmuWnd::OnMessageID_HELP_WINAMPFORUMS()
{
	TRACE(_T("Command ID_HELP_WINAMPFORUMS"));
}
void CWAEmuWnd::OnMessageID_PLAY_VOLUMEUP()
{
	TRACE(_T("Command ID_PLAY_VOLUMEUP"));
}
void CWAEmuWnd::OnMessageID_PLAY_VOLUMEDOWN()
{
	TRACE(_T("Command ID_PLAY_VOLUMEDOWN"));
}
void CWAEmuWnd::OnMessageID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY()
{
	TRACE(_T("Command ID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY"));
}
void CWAEmuWnd::OnMessageID_PEFILE_ADDFROMLIBRARY()
{
	TRACE(_T("Command ID_PEFILE_ADDFROMLIBRARY"));
}
void CWAEmuWnd::OnMessageID_PEFILE_CLOSEPLAYLISTEDITOR()
{
	TRACE(_T("Command ID_PEFILE_CLOSEPLAYLISTEDITOR"));
}
void CWAEmuWnd::OnMessageID_PEPLAYLIST_PLAYLISTPREFERENCES()
{
	TRACE(_T("Command ID_PEPLAYLIST_PLAYLISTPREFERENCES"));
}
void CWAEmuWnd::OnMessageID_MLFILE_NEWPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_NEWPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_LOADPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_LOADPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_SAVEPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_SAVEPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_ADDMEDIATOLIBRARY()
{
	TRACE(_T("Command ID_MLFILE_ADDMEDIATOLIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLFILE_CLOSEMEDIALIBRARY()
{
	TRACE(_T("Command ID_MLFILE_CLOSEMEDIALIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_NOWPLAYING()
{
	TRACE(_T("Command ID_MLVIEW_NOWPLAYING"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_ALLMEDIA()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_ALLMEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_AUDIO()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_AUDIO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_VIDEO()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_VIDEO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY()
{
	TRACE(_T("Command ID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_INTERNETRADIO()
{
	TRACE(_T("Command ID_MLVIEW_INTERNETRADIO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_INTERNETTV()
{
	TRACE(_T("Command ID_MLVIEW_INTERNETTV"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LIBRARYPREFERENCES()
{
	TRACE(_T("Command ID_MLVIEW_LIBRARYPREFERENCES"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_DEVICES_NOAVAILABLEDEVICE()
{
	TRACE(_T("Command ID_MLVIEW_DEVICES_NOAVAILABLEDEVICE"));
}
void CWAEmuWnd::OnMessageID_MLFILE_IMPORTCURRENTPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_IMPORTCURRENTPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_MEDIA()
{
	TRACE(_T("Command ID_MLVIEW_MEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_PLAYLISTS()
{
	TRACE(_T("Command ID_MLVIEW_PLAYLISTS"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_MEDIA_ALLMEDIA()
{
	TRACE(_T("Command ID_MLVIEW_MEDIA_ALLMEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_DEVICES()
{
	TRACE(_T("Command ID_MLVIEW_DEVICES"));
}
void CWAEmuWnd::OnMessageID_FILE_SHOWLIBRARY()
{
	TRACE(_T("Command ID_FILE_SHOWLIBRARY"));
}
void CWAEmuWnd::OnMessageID_FILE_CLOSELIBRARY()
{
	TRACE(_T("Command ID_FILE_CLOSELIBRARY"));
}
void CWAEmuWnd::OnMessageID_POST_PLAY_PLAYLIST()
{
	TRACE(_T("Command ID_POST_PLAY_PLAYLIST"));
}
void CWAEmuWnd::OnMessageID_VIS_NEXT()
{
	TRACE(_T("Command ID_VIS_NEXT"));
}
void CWAEmuWnd::OnMessageID_VIS_PREV()
{
	TRACE(_T("Command ID_VIS_PREV"));
}
void CWAEmuWnd::OnMessageID_VIS_RANDOM()
{
	TRACE(_T("Command ID_VIS_RANDOM"));
}
void CWAEmuWnd::OnMessageID_MANAGEPLAYLISTS()
{
	TRACE(_T("Command ID_MANAGEPLAYLISTS"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_SWITCHTOSKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_SWITCHTOSKIN"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_DELETESKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_DELETESKIN"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_RENAMESKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_RENAMESKIN"));
}
void CWAEmuWnd::OnMessageID_VIS_FS()
{
	TRACE(_T("Command ID_VIS_FS"));
}
void CWAEmuWnd::OnMessageID_VIS_CFG()
{
	TRACE(_T("Command ID_VIS_CFG"));
}
void CWAEmuWnd::OnMessageID_VIS_MENU()
{
	TRACE(_T("Command ID_VIS_MENU"));
}
void CWAEmuWnd::OnMessageID_VIS_SET_FS_FLAG()
{
	TRACE(_T("Command ID_VIS_SET_FS_FLAG"));
}
void CWAEmuWnd::OnMessageID_PE_SHOWPLAYING()
{
	TRACE(_T("Command ID_PE_SHOWPLAYING"));
}
void CWAEmuWnd::OnMessageID_HELP_REGISTERWINAMPPRO()
{
	TRACE(_T("Command ID_HELP_REGISTERWINAMPPRO"));
}
void CWAEmuWnd::OnMessageID_PE_MANUAL_ADVANCE()
{
	TRACE(_T("Command ID_PE_MANUAL_ADVANCE"));
}
void CWAEmuWnd::OnMessageWA_SONG_5_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_5_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_4_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_4_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_3_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_3_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_2_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_2_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_1_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_1_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_NO_RATING()
{
	TRACE(_T("Command WA_SONG_NO_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_5_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_5_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_4_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_4_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_3_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_3_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_2_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_2_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_1_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_1_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_NO_RATING()
{
	TRACE(_T("Command PL_SONG_NO_RATING"));
}
void CWAEmuWnd::OnMessageAUDIO_TRACK_ONE()
{
	TRACE(_T("Command AUDIO_TRACK_ONE"));
}
void CWAEmuWnd::OnMessageVIDEO_TRACK_ONE()
{
	TRACE(_T("Command VIDEO_TRACK_ONE"));
}
