#ifndef CDLLINPUT_H
#define CDLLINPUT_H

#include "StandardInput.h"

typedef In_Module* (__cdecl *winampGetInModule)(); // type definition, pointer to: void function(char*)
typedef int (__cdecl *LPwinampGetExtendedFileInfo)(
extendedFileInfoStruct ExtendedFileInfo);
typedef int (__cdecl *LPwinampGetExtendedFileInfoW)(
extendedFileInfoStructW ExtendedFileInfo);
class CDllInput : public InputInterface
{
private:
	HINSTANCE hModIn;   	  // handle to loaded library module
	winampGetInModule pfun1;   // declaration for the typedef function
	LPwinampGetExtendedFileInfo pfun2;
	LPwinampGetExtendedFileInfoW pfun3;

	In_Module* dllInMod;
	CStandardInput* internalIn;
	In_Module* internalInMod;
	int playerStatut;
public:

	int GetVersion();   	// module type (IN_VER)
	char* GetDescription();	 // description of module, with version string

	void SethMainWindow(HWND hWnd);   // winamp's main window (filled in by winamp)
	void SethDllInstance(HINSTANCE hDLL);   // DLL instance handle (Also filled in by winamp)

	char* GetFileExtensions();    // "mp3\0Layer 3 MPEG\0mp2\0Layer 2 MPEG\0mpg\0Layer 1 MPEG\0"
	// May be altered from Config, so the user can select what they want

	int isSeekable();     // is this stream seekable? 
	int isUsesOutputPlug(); 	// does this plug-in use the output plug-ins? (musn't ever change, ever :)

	void SetOutMod(Out_Module* out); // filled in by winamp, optionally used :)

	CDllInput(CString dllPath, HWND hWnd);
	~CDllInput();
	void Config(HWND hwndParent); // configuration dialog
	void About(HWND hwndParent);  // about dialog

	void Init();			 // called at program init
	void Quit();			 // called at program quit

	void GetFileInfo(TCHAR* file, TCHAR* title, int* length_in_ms); // if file == NULL, current playing is used
	int InfoBox(TCHAR* file, HWND hwndParent);

	int IsOurFile(TCHAR* fn);  // called before extension checks, to allow detection of mms://, etc
	// playback stuff
	int Play(TCHAR* fn);   // return zero on success, -1 on file-not-found, some other value on other (stopping winamp) error
	void Pause();     // pause stream
	void UnPause(); 	// unpause stream
	int IsPaused(); 	// ispaused? return 1 if paused, 0 if not
	void Stop();		// stop (unload) stream

	// time stuff
	int GetLength();	  // get length in ms
	int GetOutputTime();	// returns current output time in ms. (usually returns outMod->GetOutputTime()
	void SetOutputTime(int time_in_ms); // seeks to point in stream (in ms). Usually you signal yoru thread to seek, which seeks and calls outMod->Flush()..

	// volume stuff
	void SetVolume(int volume); // from 0 to 255.. usually just call outMod->SetVolume
	void SetPan(int pan); // from -127 to 127.. usually just call outMod->SetPan

	// info setting (filled in by winamp)
	void SetInfo(int bitrate, int srate, int stereo, int synched); // if -1, changes ignored? :)
	int GetPlayerMode();
	void SetPlayerMode(int statut);
	In_Module* GetIn_Module();
	int winampGetExtendedFileInfo(extendedFileInfoStruct ExtendedFileInfo);
	int winampGetExtendedFileInfoW(extendedFileInfoStructW ExtendedFileInfo);
};
#endif